#set of functions, directly/indirectly involved, in oneChannelGUI generalToolMenu
#oneChannelGUI   filteringTable filtering a tab delimited file on the basis of a list of probesets
#oneChannelGUI colExtract extract a user defined colum from a tab delimited file with header
#oneChannelGUI geneExonLibs queries affymetrix web site to download exon and gene 1.0 ST WT library files
#oneChannelGUI ngsperlDownload creating dir with ngs perl scripts
#oneChannelGUI NGSreformat uses perl scripts to reformat the output of shrimp  v2 in 
#oneChannelGUI aptFolder setting the folder were apt tools are located (save data in localdata.txt in etc)
#oneChannelGUI deleteLocalData delete data in localdata.txt resetting aptDir and libDirLocation
#oneChannelGUI buildingLocalAnnotation updates gene level annotation using the netaffx annotation data
#                                      exon level annotation is done using the UCSC exon-level annotation data
#oneChannelGUI refseqDownload retrieve the latest Hs, Mm, Rn refseq fasta file
#oneChannelGUI madscrosshybDownload and creation of mads derived mps file only available for Hs and Mm core  NOT FINISHED
#oneChannelGUI updateLibs run an update of the Bioconductor libraries
#oneChannelGUI variantExons the function updates the table available in oneChannelGUI that contains only variant exons
#             for the core set. variant exons are those that are present only in a subset of isoforms associated to a gene to the UCSC browser
#oneChannelGUI exportFASTA  Export non-coding RNA fasta file for RNA-seq
#oneChannelGUI meVDownload setting the folder were meV software (http://www.tm4.org/mev/) is located  (save data in localdata.txt in etc)
#oneChannelGUI extPckInfo show which external software are available and in which dir
#oneChannelGUI combining2eSet combine two tables with the same row names
#################################################################################
#this file contains a set of function that perfomr basic R function useful for handlying microarray data.
#this function filter a table on the basis of a vector of data present in an other file
"filteringTable" <- function(){
    Try(tkmessageBox(title="Table subsetting",message="Open the file to be filtered. This file should be tab delimited with an header."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(saving.file <- paste(tempFileName, ".filtered.by.",sep=""))
    Try(mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(tkmessageBox(title="Table subsetting",message="Open the file to be used to filter the previous file.\nThis file should contain a single column with an header equal to \nthe one that should be used for filtering in the tab delimited file."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(tmp <- as.vector(unlist(strsplit(tempFileName , "/"))))
    Try(saving.file <- paste(saving.file, tmp[length(tmp)],sep=""))
    Try(myFilter<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(col.for.filter <- which(names(mySel)==names(myFilter)[1]))
    Try(mySel <- mySel[which(mySel[,col.for.filter]%in%myFilter[,1]),])
    Try(tkmessageBox(title="Table subsetting",message="Saving the filtered table."))
	  Try(FileName <- tclvalue(tkgetSaveFile(initialfile=saving.file, filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if(!nchar(FileName))
		    	return())
		Try(write.table(mySel,file=FileName,quote=FALSE,col.names=NA,sep="\t"))
   
}
################################################################################
"colExtract" <- function(){
    Try(tkmessageBox(title="Column extraction",message="Open the file to be manipulated. This file should be tab delimited with an header."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(mycol <- names(mySel))
    Try(mycol <- paste(mycol, "=",seq(1, length(mycol)), sep="", collapse=" "))
    
          #selecting the column to be removed
                 Try(ttcolExtract<-tktoplevel(.affylmGUIglobals$ttMain))
                 Try(tkwm.deiconify(ttcolExtract))
                 Try(tkgrab.set(ttcolExtract))
                 Try(tkfocus(ttcolExtract))
                 Try(tkwm.title(ttcolExtract,"Defining the column to be estracted"))
                 Try(tkgrid(tklabel(ttcolExtract,text="    ")))
                 Try(colnum <- "1")
                 Try(Local.colExtract <- tclVar(init=colnum))
                 Try(entry.colExtract <-tkentry(ttcolExtract,width="4",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.colExtract,bg="white"))
                 Try(tkgrid(tklabel(ttcolExtract,text=paste("Please enter the number associated to the columnof interest\n", mycol,collapse=" "),font=.affylmGUIglobals$affylmGUIfont2)))
                 Try(tkgrid(entry.colExtract))
                 onOK <- function()
                 {
                     Try(colnum <- as.numeric(tclvalue(Local.colExtract)))
                     Try(assign("colnum", as.numeric(tclvalue(Local.colExtract)),affylmGUIenvironment))
                     Try(tkgrab.release(ttcolExtract));Try(tkdestroy(ttcolExtract));Try(tkfocus(.affylmGUIglobals$ttMain))                        
                 }
                 Try(OK.but <-tkbutton(ttcolExtract,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
                 Try(tkgrid(tklabel(ttcolExtract,text="    ")))
                 Try(tkgrid(OK.but))
                 Try(tkgrid.configure(OK.but))
                 Try(tkgrid(tklabel(ttcolExtract,text="       ")))
                 Try(tkfocus(entry.colExtract))
                 Try(tkbind(entry.colExtract, "<Return>",onOK))
                 Try(tkbind(ttcolExtract, "<Destroy>", function(){Try(tkgrab.release(ttcolExtract));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
                 Try(tkwait.window(ttcolExtract))
                 Try(tkfocus(.affylmGUIglobals$ttMain))
                 Try(colnum <- get("colnum", affylmGUIenvironment))
                 if(colnum > length(names(mySel))){
                         Try(tkmessageBox(title="Column extraction",message="You have selected a non existing column!"))
                         return()
                 }
    
    Try(tempFileName <- as.vector(unlist(strsplit(tempFileName, "/"))))
    Try(if(length(tempFileName) > 1)  tempFileName <- tempFileName[length(tempFileName)])
    Try(saving.file <- paste("col.",colnum,".from.",tempFileName,".txt",sep=""))
    Try(tkmessageBox(title="Column extraction",message="Saving the extracted column."))
	  Try(FileName <- tclvalue(tkgetSaveFile(initialfile=saving.file, filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if(!nchar(FileName))
		    	return())
    Try(myout <- as.character(as.vector(mySel[,colnum])))
    Try(zz <- file(FileName, "w"))
    Try(writeLines(myout, con = zz, sep = "\n"))
    Try(close(zz))

}
################################################################################
#save affy libraries in allylibs dir as new dir in oneChannelPath
 "geneExonLibs" <- function(){
      Try(tkmessageBox(title="Gene Exon 1.0 ST libraries",message="This routine installs, in a user defined folder,\nall library files needed for analysis of Gene/Exon Affymetrix arrays."))
      Try(myWD <- getwd())
      #Try(SetWD())
      Try(libDirLocation <- get("libDirLocation",envir=affylmGUIenvironment))
      if(libDirLocation != ""){
             Try(mbVal <- tkmessageBox(title="Gene Exon 1.0 ST libraries",
				    											message="There already a folder defined for Affymetrix libraries.\nDo you want to change it?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		        )#end of Try(mbVal..
    		    if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(setwd(myWD))
			            return()
		       } else{
                    Try(.downloadLibs())
                    Try(setwd(myWD))
                    return()
           } 
      }
   Try(.downloadLibs())
   Try(setwd(myWD))
}

".downloadLibs" <- function(){
                     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
                     Try(libDirLocation  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs", sep=""))
                     Try(dir.create(libDirLocation, showWarnings = TRUE, recursive = FALSE))
                     Try(setwd(libDirLocation))
                     Try(assign("libDirLocation", libDirLocation, affylmGUIenvironment))#directory where affy library files are located
                     Try(cat("\nBegin downloads of library files.....\n"))
                     Try(cat("Be patient!\n"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/HuEx.zip", "HuEx.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/HuGene.zip","HuGene.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/MoEx.zip", "MoEx.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/MoGene.zip","MoGene.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/RaEx.zip","RaEx.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/RaGene.zip","RaGene.zip", mode="wb"))

               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/HuEx-1_0-st-v2.r2.zip", "HuEx-1_0-st-v2.r2.zip", method="wget"))
               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/MoEx-1_0-st-v1_libraryfile.zip", "MoEx-1_0-st-v1_libraryfile.zip"))
               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/RaEx-1_0-st-v1_libraryfile.zip","RaEx-1_0-st-v1_libraryfile.zip"))
               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/HuGene-1_0-st-v1.r3.analysis_libraryfile.zip","HuGene-1_0-st-v1.r3.analysis_libraryfile.zip"))
                     Try(cat("\nEnd downloads of 6 library files.....\n"))
                     Try(cat("\nBegin unzip library files.....\n"))
                     if(.Platform$OS.type=="windows"){
                         Try(unzipped1 <- zip.unpack("HuGene.zip", getwd()))
                         cat("\nHuGene zip contains: \n", unzipped1, "\n")
                         Try(if(length(unzipped1) < 8) cat("\nHuGene should contain at least 8 files\n"))
                         Try(unzipped2 <- zip.unpack("HuEx.zip", getwd()))
                         cat("\nHuEx zip contains: \n", unzipped2, "\n")
                         Try(if(length(unzipped2) < 16) cat("\nHuEx should contain at least 16 files\n"))
                         Try(unzipped3 <- zip.unpack("MoEx.zip", getwd()))
                         cat("\nMoEx zip contains: \n", unzipped3, "\n")
                         Try(if(length(unzipped3) < 17) cat("\nMoEx should contain at least 17 files\n"))
                         Try(unzipped4 <- zip.unpack("MoGene.zip", getwd()))
                         cat("\nMoGene zip contains: \n", unzipped4, "\n")
                         Try(if(length(unzipped4) < 8) cat("\nMoGene should contain at least 8 files\n"))
                         Try(unzipped5 <- zip.unpack("RaEx.zip", getwd()))
                         cat("\nRaEx zip contains: \n", unzipped5, "\n")
                         Try(if(length(unzipped5) < 16) cat("\nRaEx should contain at least 16 files\n"))
                         Try(unzipped6 <- zip.unpack("RaGene.zip", getwd()))
                         cat("\nMoGene zip contains: \n", unzipped6, "\n")
                         Try(if(length(unzipped6) < 8) cat("\nRaGene should contain at least 8 files\n"))
                     } else{
                       Try(system(paste("unzip HuGene.zip", sep="")))
                       Try(system(paste("unzip HuEx.zip")))
                       Try(system(paste("unzip MoEx.zip")))
                       Try(system(paste("unzip MoGene.zip")))
                       Try(system(paste("unzip RaEx.zip")))
                       Try(system(paste("unzip RaGene.zip")))
                     }
                     Try(cat("\nEnd unzip library files.....\n"))
                     Try(cat("\nLibrary files are ready to be used in ", getwd(),"\n"))
                     #save the info to be recovered in a new session
                     Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
                     Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
                     Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                     Try(myinfo[which(myinfo[,1]=="libDirLocation"),2] <- libDirLocation)
                     Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
                     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
#######################################################################################################
#define the folder where apt tools are locate
"aptFolder" <- function(){
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
      Try(tkmessageBox(title="APT tools folder",message="Please select the folder where APT tools are located."))
      Try(myWD <- getwd())
      #Try(SetWD())
      Try(aptDir <- get("aptDir",envir=affylmGUIenvironment))
      if(is.na(aptDir)){aptDir <- ""}
      if(aptDir == ""){
            Try(SetED())
            Try(aptDir <- getwd())
            if(length(grep("apt-probeset-summarize", dir(paste(aptDir, "/bin", sep="")))) == 0){
                      Try(tkmessageBox(title="APT tools dir ",message="You have not correctly defined the main folder where APT tools are located!",icon="error"))
                      assign("aptDir.Available",FALSE,affylmGUIenvironment)
                      assign("aptDir", "" ,affylmGUIenvironment)
                      Try(setwd(myWD))
                      #Try(return())
            } else {
                       Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
                       Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                       Try(myinfo[which(myinfo[,1]=="aptDir"),2] <- aptDir)
                       Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
                       assign("aptDir.Available",TRUE,affylmGUIenvironment)
                       assign("aptDir", aptDir ,affylmGUIenvironment)
                       Try(setwd(myWD))
                       #Try(return())
            }
      } else{
                      Try(mbVal <- tkmessageBox(title="APT tools folder",
				    											message="There already a folder defined for APT tools.\nDo you want to change it?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		                  )#end of Try(mbVal..
    		              if(tclvalue(mbVal)=="no"){
			                        Try(tkfocus(.affylmGUIglobals$ttMain))
			                        Try(setwd(myWD))
			                        return()
		                  } 
                      if(tclvalue(mbVal)=="yes"){
                              Try(SetED())
                              Try(aptDir <- getwd())
                              if(length(grep("apt-probeset-summarize", dir(paste(aptDir, "/bin", sep="")))) == 0){
                                  Try(tkmessageBox(title="APT tools dir ",message="You have not correctly defined the main folder where APT tools are located!",icon="error"))
                                  assign("aptDir.Available",FALSE,affylmGUIenvironment)
                                  assign("aptDir", "" ,affylmGUIenvironment)
                                  Try(setwd(myWD))
                                  #Try(return())
                              } else {
                                 Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
                                 Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                                 Try(myinfo[which(myinfo[,1]=="aptDir"),2] <- aptDir)
                                 Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
                                 assign("aptDir.Available",TRUE,affylmGUIenvironment)
                                 assign("aptDir", aptDir ,affylmGUIenvironment)
                                 Try(setwd(myWD))
                                 #Try(return())
                             }
                      }      
           }
           
           Try(mbVal <- tkmessageBox(title="RefSeq Fasta",
				    											message="Do you wish to download reference sequence for exon-level analysis?\nIf you answer NO oneChannelGUI you can also do it later. Be patient!",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		  )#end of Try(mbVal..
    	if(tclvalue(mbVal)=="yes"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(refseqDownload())
                  Try(tkmessageBox(title="APT tools folder",message="Please install the BLAST executable in the apt/blast dir.\nDownload the BAST from ftp://ftp.ncbi.nih.gov/blast/executables/LATEST"))
      }
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
###########################################################################################
"deleteLocalData" <- function(){
          Try(mbVal <- tkmessageBox(title="Local setting",
				    											message="Do you want to the delete the local setting for Gene Exon arrays analysis?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		        )#end of Try(mbVal..
    		    if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            return()
		       } else{
                    Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
                    Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
                    Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                    Try(myinfo[which(myinfo[,1]=="libDirLocation"),2] <- "")
                    Try(myinfo[which(myinfo[,1]=="aptDir"),2] <- "")
                    Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names= F, quote=F))
                    Try(tkmessageBox(title="Local settings",message="Local setting were reset."))
                    return()
           } 

}
################################################################################
#building gene and exon annotation for oneChannelGUI 
"buildingLocalAnnotation" <- function(){
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
    Try(require("AffyCompatible") || stop("\nMissing AffyCompatible library\n"))
    Try(libDirLocation <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs/", sep = ""))
    #gathering affy libs and apt tools folders
    Try(netaffxUpdates  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/netaffxUpdates.txt", sep=""))
    Try(cat(readLines(netaffxUpdates), sep="\n"))
    #username
    Try(ttGetUserName<-tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.deiconify(ttGetUserName))
    Try(tkgrab.set(ttGetUserName))
    Try(tkfocus(ttGetUserName))
    Try(tkwm.title(ttGetUserName,"NetAffx User Name"))
    Try(tkgrid(tklabel(ttGetUserName,text="    ")))
    Try(UserNameText <- "")
    Try(Local.UserName <- tclVar(init=UserNameText))
    Try(entry.UserName <-tkentry(ttGetUserName,width="30",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.UserName,bg="white"))
    Try(tkgrid(tklabel(ttGetUserName,text="Please enter your NetAffx User Name.",font=.affylmGUIglobals$affylmGUIfont2)))
    Try(tkgrid(entry.UserName))
    onOK <- function()
    {
       Try(UserNameText <- tclvalue(Local.UserName))
       if(nchar(UserNameText)==0)
           UserNameText <- "Unselected"
       Try(assign("UserNameText",UserNameText,affylmGUIenvironment))
       Try(tclvalue(.affylmGUIglobals$UserNameTcl) <- UserNameText)
       Try(tkgrab.release(ttGetUserName));Try(tkdestroy(ttGetUserName));Try(tkfocus(.affylmGUIglobals$ttMain))
    }
    Try(OK.but <-tkbutton(ttGetUserName,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttGetUserName,text="    ")))
    Try(tkgrid(OK.but))
    Try(tkgrid.configure(OK.but))
    Try(tkgrid(tklabel(ttGetUserName,text="       ")))
    Try(tkfocus(entry.UserName))
    Try(tkbind(entry.UserName, "<Return>",onOK))
    Try(tkbind(ttGetUserName, "<Destroy>", function(){Try(tkgrab.release(ttGetUserName));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
    Try(tkwait.window(ttGetUserName))
    Try(tkfocus(.affylmGUIglobals$ttMain))
    #########################
    #password
    Try(ttGetUserPw<-tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.deiconify(ttGetUserPw))
    Try(tkgrab.set(ttGetUserPw))
    Try(tkfocus(ttGetUserPw))
    Try(tkwm.title(ttGetUserPw,"NetAffx User Password"))
    Try(tkgrid(tklabel(ttGetUserPw,text="    ")))
    Try(UserPwText <- "")
    Try(Local.UserPw <- tclVar(init=UserPwText))
    Try(entry.UserPw <-tkentry(ttGetUserPw,width="20",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.UserPw,bg="white"))
    Try(tkgrid(tklabel(ttGetUserPw,text="Please enter your NetAffx User Password.",font=.affylmGUIglobals$affylmGUIfont2)))
    Try(tkgrid(entry.UserPw))
    onOK <- function()
    {
       Try(UserPwText <- tclvalue(Local.UserPw))
       if(nchar(UserPwText)==0)
           UserPwText <- "Unselected"
       Try(assign("UserPwText",UserPwText,affylmGUIenvironment))
       Try(tclvalue(.affylmGUIglobals$UserPwTcl) <- UserPwText)
       Try(tkgrab.release(ttGetUserPw));Try(tkdestroy(ttGetUserPw));Try(tkfocus(.affylmGUIglobals$ttMain))
    }
    Try(OK.but <-tkbutton(ttGetUserPw,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttGetUserPw,text="    ")))
    Try(tkgrid(OK.but))
    Try(tkgrid.configure(OK.but))
    Try(tkgrid(tklabel(ttGetUserPw,text="       ")))
    Try(tkfocus(entry.UserPw))
    Try(tkbind(entry.UserPw, "<Return>",onOK))
    Try(tkbind(ttGetUserPw, "<Destroy>", function(){Try(tkgrab.release(ttGetUserPw));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
    Try(tkwait.window(ttGetUserPw))
    Try(tkfocus(.affylmGUIglobals$ttMain))
    #########################
    Try(username.tmp <- get("UserNameText", env=affylmGUIenvironment))
    Try(userpw.tmp <- get("UserPwText", env=affylmGUIenvironment))
    if(username.tmp != "Unselected" & userpw.tmp != "Unselected"){
         Try(rsrc <- NetAffxResource(user = username.tmp, password = userpw.tmp, affxLicence = "BIOCON0808"))
         Try(rsrc)
         #selecting the annotation to be updated
         Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
         Try(tkwm.deiconify(ttIfDialog))
         Try(tkgrab.set(ttIfDialog))
         Try(tkfocus(ttIfDialog))
         Try(tkwm.title(ttIfDialog,"Defining the Gene level annotation file to be updated"))
         Try(tkgrid(tklabel(ttIfDialog,text="    ")))
         Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
         Try(HowManyQuestion1 <- tklabel(frame1,text="Select the genechip of interest",font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(HowManyQuestion1))
         Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
         Try(netaffxTcl <- tclVar("none"))
         Try(I1.but  <- tkradiobutton(frame1,text="Human exon genechip: HuEx",variable=netaffxTcl,value="HuEx",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I2.but  <- tkradiobutton(frame1,text="Human gene genechip: HuGene",variable=netaffxTcl,value="HuGene-",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I3.but  <- tkradiobutton(frame1,text="Mouse exon genechip: MoEx",variable=netaffxTcl,value="MoEx",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I4.but  <- tkradiobutton(frame1,text="Mouse gene genechip: MoGene",variable=netaffxTcl,value="MoGene-",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I5.but  <- tkradiobutton(frame1,text="Rat exon genechip: RaEx",variable=netaffxTcl,value="RaEx",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I6.but  <- tkradiobutton(frame1,text="Rat gene genechip: RaGene",variable=netaffxTcl,value="RaGene-",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I7.but  <- tkradiobutton(frame1,text="None",variable=netaffxTcl,value="none",font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(I1.but,sticky="w"))
         Try(tkgrid(I2.but,sticky="w"))
         Try(tkgrid(I3.but,sticky="w"))
         Try(tkgrid(I4.but,sticky="w"))
         Try(tkgrid(I5.but,sticky="w"))
         Try(tkgrid(I6.but,sticky="w"))
         Try(tkgrid(I7.but,sticky="w"))
         Try(tkgrid.configure(HowManyQuestion1,I1.but,I2.but,I3.but,I4.but,I5.but,I6.but,I7.but,sticky="w"))
         Try(onOK <- function()
         {
             Try(ReturnNetaffx <<- as.character(tclvalue(netaffxTcl)))
             Try(tkgrab.release(ttIfDialog))
             Try(tkdestroy(ttIfDialog))
             Try(tkfocus(.affylmGUIglobals$ttMain))
         })
         Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
         Try(onCancel <- function() {
              Try(tkgrab.release(ttIfDialog))
              Try(tkdestroy(ttIfDialog))
              Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
         })
         Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
         Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,tklabel(ttIfDialog,text="  ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    ")))
         Try(tkgrid.configure(frame1,frame3,sticky="w"))
         Try(tkfocus(ttIfDialog))
         Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
         Try(tkwait.window(ttIfDialog))
         if(ReturnNetaffx == "none"){
                Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
          	    Try(tkfocus(.affylmGUIglobals$ttMain))
                Try(return())
         }
         if(ReturnNetaffx != "none"){
               Try(annos <- rsrc[[grep(ReturnNetaffx, names(rsrc))]])
               #gene level
               Try(anno <- affxAnnotation(annos)[[grep("Transcript Cluster Annotations, CSV", affxDescription(rsrc[[grep(ReturnNetaffx, names(rsrc))]]))]])   #"transcript clusters Annotation, CSV Format"
               Try(df <- readAnnotation(rsrc, annotation = anno, content=FALSE))
               Try(df1 <- as.character(unlist(strsplit(df, ".zip"))))
               Try(df1 <- as.character(unlist(strsplit(df1,'/'))))
               Try(df1 <- df1[length(df1)])
               Try(conn <- unz(df, df1))
               Try(tmp <- readLines(conn, n=500))
               Try(myskip <- grep("transcript_cluster_id", tmp))
               Try(df.ann <- read.csv(conn, skip= (myskip - 1), header=T, as.is=T))
               Try(df.ann <- df.ann[,which(names(df.ann)%in%c("probeset_id", "gene_assignment"))])
               #IMPORTANT to build the GENE level oneChannelGUI annotation file I use only the first assignment mapped on the gen_assignment field in the annotation files
               
               geneAnnExtraction <- function(x){
                                                 mx <- strsplit(x, '//')
                                                 mx <- as.vector(unlist(mx))
                                                 if(length(mx) >= 4){
                                                       mx <- mx[1:4]
                                                       mxtmp <- gsub(" ", "", mx[c(1:2,4)])
                                                       mx <- c(mxtmp[1:2], mx[3], mxtmp[3])
                                                       return(mx)
                                                 } else{
                                                     mx <- rep(NA, 4)
                                                     return(mx)
                                                 }
                                    }
               
               myann <- sapply(df.ann[,2], geneAnnExtraction)
               myann <- t(myann)
               rownames(myann) <- df.ann[,1]
               df.ann <- cbind(df.ann[,1], myann)
               df.ann <- as.data.frame(df.ann)
               names(df.ann) <- c("PROBESETID","ACC","SYMBOL","DESCRIPTION","CYTOBAND")
               
               #exon level
               if(length(grep("Probeset Annotations, CSV Format", affxDescription(rsrc[[grep(ReturnNetaffx, names(rsrc))]]))) > 0){
                 Try(annops <- affxAnnotation(annos)[[grep("Probeset Annotations, CSV Format", affxDescription(rsrc[[grep(ReturnNetaffx, names(rsrc))]]))]])   #"exon probe set level Annotation, CSV Format"
                 Try(dfps <- readAnnotation(rsrc, annotation = annops, content=FALSE))
                 Try(df1ps <- as.character(unlist(strsplit(dfps, ".zip"))))
                 Try(df1ps <- as.character(unlist(strsplit(df1ps,'/'))))
                 Try(df1ps <- df1ps[length(df1ps)])
                 Try(connps <- unz(dfps, df1ps))

                 Try(tmpps <- readLines(connps, n=500))
                 Try(myskipps <- grep("probeset_id", tmpps))
                 Try(df.annps <- read.csv(connps, skip= (myskipps - 1), header=T, as.is=T))
                 Try(df.annps <- df.annps[,which(names(df.annps)%in%c("probeset_id", "seqname", "strand", "start", "stop", "transcript_cluster_id","level"))])
                 Try(names(df.annps) <- c("EPROBESETID", "CHR", "STRAND", "START", "STOP", "GPROBESETID","ANNLEVEL"))
               }
               ####
               if(ReturnNetaffx == "HuEx"){
                       huex.annotation <- df.ann
                       save(huex.annotation, file="huex.annotation.rda")
                       #hs exon-level probesets
                       cat("\nCreating annotation for Hs exon-level probesets. \nBased on USCS golden path data from hg18 genome release\n")
                       download.file("ftp://hgdownload.cse.ucsc.edu/goldenPath/hg18/database/affyAllExonProbes.txt.gz", "affyAllExonProbes.txt.gz", mode="wb")
                       cat(".")
                       zz <- gzfile("affyAllExonProbes.txt.gz","r")
                       cat(".")
                       tmp <- readLines(con=zz)
                       cat(".")
                       close(zz)
                       tmp <- strsplit(tmp, "\t")
                       cat(".")
                       tmp <- as.data.frame(do.call(rbind, tmp), stringsAsFactors=F)
                       cat(".")
                       names(tmp) <- c("X", "CHR", "START", "STOP", "NAME", "SCORE", "STRAND")
                       tmp1 <- tmp$NAME
                       tmp1 <- strsplit(as.character(tmp1), "\\|")
                       cat(".")
                       eid <- sapply(tmp1, function(x)x[1])
                       cat(".")
                       eann <- sapply(tmp1, function(x)x[2])
                       cat(".")
                       crosshybhuex.annotation <- data.frame(eid, as.character(tmp[,2]), as.character(tmp[,3]), as.character(tmp[,4]), as.character(tmp[,7]), eann, as.character(tmp[,6]), stringsAsFactors=F)
                       names(crosshybhuex.annotation) <- c("EPROBESETID", "CHR", "START", "STOP", "STRAND", "ANNLEVEL", "SCORE")
                       cat(".")
                       df.annps <- df.annps[which(df.annps$EPROBESETID %in% crosshybhuex.annotation$EPROBESETID),]
                       crosshybhuex.annotation <- crosshybhuex.annotation[which(crosshybhuex.annotation$EPROBESETID %in% df.annps$EPROBESETID),]
                       df.annps <- df.annps[order(df.annps$EPROBESETID),]
                       crosshybhuex.annotation <- crosshybhuex.annotation[order(crosshybhuex.annotation$EPROBESETID),]
                       if(identical(as.character(df.annps$EPROBESETID), crosshybhuex.annotation$EPROBESETID)){
                                     crosshybhuex.annotation <- cbind(crosshybhuex.annotation$EPROBESETID, as.character(df.annps$GPROBESETID), crosshybhuex.annotation[,2:dim(crosshybhuex.annotation)[2]])
                                     names(crosshybhuex.annotation)[1] <- "EPROBESETID"
                                     names(crosshybhuex.annotation)[2] <- "GPROBESETID"
                                     save(crosshybhuex.annotation, file="crosshybhuex.annotation.rda")
                       } else{
                                     cat("\nInternal error in buildingLocalAnnotation function. \nPlease report to oneChannelGUI maintainer raffaele.calogero@unito.it\n")
                                     return()
                       }
               }
               if(ReturnNetaffx == "HuGene-"){
                       hugene.annotation <- df.ann
                       save(hugene.annotation, file="hugene.annotation.rda")
               }
               if(ReturnNetaffx == "MoEx"){
                       moex.annotation <- df.ann
                       save(moex.annotation, file="moex.annotation.rda")
                       #mm exon-level probesets
                       cat("\nCreating annotation for Mm exon-level probesets. \nBased on USCS golden path data from mm9 genome release\n")
                       download.file("ftp://hgdownload.cse.ucsc.edu/goldenPath/mm9/database/affyAllExonProbes.txt.gz", "affyAllExonProbes.txt.gz", mode="wb")
                       cat(".")
                       zz <- gzfile("affyAllExonProbes.txt.gz","r")
                       cat(".")
                       tmp <- readLines(con=zz)
                       cat(".")
                       close(zz)
                       tmp <- strsplit(tmp, "\t")
                       cat(".")
                       tmp <- as.data.frame(do.call(rbind, tmp), stringsAsFactors=F)
                       cat(".")
                       names(tmp) <- c("X", "CHR", "START", "STOP", "NAME", "SCORE", "STRAND")
                       tmp1 <- tmp$NAME
                       tmp1 <- strsplit(as.character(tmp1), "\\|")
                       cat(".")
                       eid <- sapply(tmp1, function(x)x[1])
                       cat(".")
                       eann <- sapply(tmp1, function(x)x[2])
                       cat(".")
                       crosshybmoex.annotation <- data.frame(eid, as.character(tmp[,2]), as.character(tmp[,3]), as.character(tmp[,4]), as.character(tmp[,7]), eann, as.character(tmp[,6]), stringsAsFactors=F)
                       names(crosshybmoex.annotation) <- c("EPROBESETID", "CHR", "START", "STOP", "STRAND", "ANNLEVEL", "SCORE")
                       cat(".")
                       df.annps <- df.annps[which(df.annps$EPROBESETID %in% crosshybmoex.annotation$EPROBESETID),]
                       crosshybmoex.annotation <- crosshybmoex.annotation[which(crosshybmoex.annotation$EPROBESETID %in% df.annps$EPROBESETID),]
                       df.annps <- df.annps[order(df.annps$EPROBESETID),]
                       crosshybmoex.annotation <- crosshybmoex.annotation[order(crosshybmoex.annotation$EPROBESETID),]
                       if(identical(as.character(df.annps$EPROBESETID), crosshybmoex.annotation$EPROBESETID)){
                                     crosshybmoex.annotation <- cbind(crosshybmoex.annotation$EPROBESETID, as.character(df.annps$GPROBESETID), crosshybmoex.annotation[,2:dim(crosshybmoex.annotation)[2]])
                                     names(crosshybmoex.annotation)[1] <- "EPROBESETID"
                                     names(crosshybmoex.annotation)[2] <- "GPROBESETID"
                                     save(crosshybmoex.annotation, file="crosshybmoex.annotation.rda")
                       } else{
                                     cat("\nInternal error in buildingLocalAnnotation function. \nPlease report to oneChannelGUI maintainer raffaele.calogero@unito.it\n")
                                     return()
                       }
               }
               if(ReturnNetaffx == "MoGene-"){
                       mogene.annotation <- df.ann
                       save(mogene.annotation, file="mogene.annotation.rda")
               }
               if(ReturnNetaffx == "RaEx"){
                       raex.annotation <- df.ann
                       save(raex.annotation, file="raex.annotation.rda")
                       #rm exon-level probesets
                       cat("\nCreating annotation for Rn exon-level probesets. \nBased on USCS golden path data from rn4 genome release\n")
                       download.file("ftp://hgdownload.cse.ucsc.edu/goldenPath/rn4/database/affyAllExonProbes.txt.gz", "affyAllExonProbes.txt.gz", mode="wb")
                       cat(".")
                       zz <- gzfile("affyAllExonProbes.txt.gz","r")
                       cat(".")
                       tmp <- readLines(con=zz)
                       cat(".")
                       close(zz)
                       tmp <- strsplit(tmp, "\t")
                       cat(".")
                       tmp <- as.data.frame(do.call(rbind, tmp), stringsAsFactors=F)
                       cat(".")
                       names(tmp) <- c("X", "CHR", "START", "STOP", "NAME", "SCORE", "STRAND")
                       tmp1 <- tmp$NAME
                       tmp1 <- strsplit(as.character(tmp1), "\\|")
                       cat(".")
                       eid <- sapply(tmp1, function(x)x[1])
                       cat(".")
                       eann <- sapply(tmp1, function(x)x[2])
                       cat(".")
                       crosshybraex.annotation <- data.frame(eid, as.character(tmp[,2]), as.character(tmp[,3]), as.character(tmp[,4]), as.character(tmp[,7]), eann, as.character(tmp[,6]), stringsAsFactors=F)
                       names(crosshybraex.annotation) <- c("EPROBESETID", "CHR", "START", "STOP", "STRAND", "ANNLEVEL", "SCORE")
                       cat(".")
                       df.annps <- df.annps[which(df.annps$EPROBESETID %in% crosshybraex.annotation$EPROBESETID),]
                       crosshybraex.annotation <- crosshybraex.annotation[which(crosshybraex.annotation$EPROBESETID %in% df.annps$EPROBESETID),]
                       df.annps <- df.annps[order(df.annps$EPROBESETID),]
                       crosshybraex.annotation <- crosshybraex.annotation[order(crosshybraex.annotation$EPROBESETID),]
                       if(identical(as.character(df.annps$EPROBESETID), crosshybraex.annotation$EPROBESETID)){
                                     crosshybraex.annotation <- cbind(crosshybraex.annotation$EPROBESETID, as.character(df.annps$GPROBESETID), crosshybraex.annotation[,2:dim(crosshybraex.annotation)[2]])
                                     names(crosshybraex.annotation)[1] <- "EPROBESETID"
                                     names(crosshybraex.annotation)[2] <- "GPROBESETID"
                                     save(crosshybraex.annotation, file="crosshybraex.annotation.rda")
                       } else{
                                     cat("\nInternal error in buildingLocalAnnotation function. \nPlease report to oneChannelGUI maintainer raffaele.calogero@unito.it\n")
                                     return()
                       }
               }
               if(ReturnNetaffx == "RaGene-"){
                       ragene.annotation <- df.ann
                       save(ragene.annotation, file="ragene.annotation.rda")
               }
               
               Try(tkmessageBox(title="Annotation data update",message=paste("\n", ReturnNetaffx, "annotation file was correctly updated in oneChannelGUI\n"),type="ok",icon="info"))
               Try(zz <- file(netaffxUpdates, "a"))  # open an output file connection
               Try(writeLines(paste(ReturnNetaffx, "annotation file was updated on", as.character(Sys.Date())), zz))
               Try(close(zz))
         }
    } else {
         Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
         Try(tkmessageBox(title="Annotation update",message="User or password for netaffx was not inserted!",type="ok",icon="error"))
   	     Try(tkfocus(.affylmGUIglobals$ttMain))
         Try(return())
    }
    
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
    Try(return())
}
################################################################################
"refseqDownload" <- function(){
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
       Try(aptDir <- get("aptDir",envir=affylmGUIenvironment))
       Try(home <- getwd())
       Try(blastDir <- paste(aptDir, "/blast/", sep=""))
       Try(setwd(blastDir))
       Try(cat("\nBegin downloads of fasta files.....\n"))
       Try(cat("Be patient!\n"))
       require(Biostrings) || stop("library Biostrings could not be found !")
       Try(download.file("ftp://ftp.ncbi.nih.gov/refseq/H_sapiens/mRNA_Prot/human.rna.fna.gz", "human.rna.fna.gz", mode="wb"))
       #Try(refseq <- read.DNAStringSet(zz, "fasta"))
       #Try(write.XStringSet(refseq, file="hs.fa", format="fasta"))
       Try(download.file("ftp://ftp.ncbi.nih.gov/refseq/M_musculus/mRNA_Prot/mouse.rna.fna.gz", "mouse.rna.fna.gz", mode="wb"))
       Try(download.file("ftp://ftp.ncbi.nih.gov/refseq/R_norvegicus/mRNA_Prot/rat.rna.fna.gz", "rat.rna.fna.gz", mode="wb"))
       Try(cat("\nEnd downloads of 3 RefSeq fasta files.....\n"))
       Try(mbVal <- tkmessageBox(title="RefSeq Fasta",
				    											message=paste("Do you wish to unpack manually the gz files in ", getwd(), "\n If you answer NO oneChannelGUI will handle unpacking,\nbut the procedure can be quite long. Be patient!"),
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		  )#end of Try(mbVal..
    	if(tclvalue(mbVal)=="yes"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(cat("\nRefSeq fasta gz files are located in ", getwd(),"\n"))
			            Try(setwd(home))
			            return()
		  }
      Try(zz <- gzfile("human.rna.fna.gz", "r"))
      Try(refseq <- readFASTA(zz, strip.desc=TRUE))
      Try(writeFASTA(refseq, file="human.rna.fna", width=80))
      Try(zz <- gzfile("mouse.rna.fna.gz", "r"))
      Try(refseq <- readFASTA(zz, strip.desc=TRUE))
      Try(writeFASTA(refseq, file="mouse.rna.fna", width=80))
      Try(zz <- gzfile("rat.rna.fna.gz", "r"))
      Try(refseq <- readFASTA(zz, strip.desc=TRUE))
      Try(writeFASTA(refseq, file="rat.rna.fna", width=80))
                 
      Try(cat("\nRefSeq fasta files are ready to be used in ", getwd(),"\n"))
      Try(setwd(home))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))              
}

################################################################################
#"madscrosshybDownload" <- function(){
#    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
#    Try(home <- getwd())
#    Try(libDirLocation <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs/", sep = ""))
#    Try(setwd(libDirLocation))
    #gathering affy libs and apt tools folders
#    Try(cat("\nBegin downloads of MADS CrossHyb data.....\n"))
#    Try(cat("Be patient!\n"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Human_CrossHyb.txt", "Human_CrossHyb.txt", mode="w"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Mouse_CrossHyb.txt", "Mouse_CrossHyb.txt", mode="w"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Human_CrossHyb_core.txt", "Human_CrossHyb_core.txt", mode="w"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Mouse_CrossHyb_core.txt", "Mouse_CrossHyb_core.txt", mode="w"))
#    Try(cat("\nEnd downloads of Human and Mouse MADS crosshyb files.....\n"))
#    hs <- read.table("Human_CrossHyb_core.txt", sep="\t", header=T, as.is=T)
    
    #building a mps without crosshyb exon probe sets, selecting bad probes on the basis of MADS approach
#    mm <- read.table("Mouse_CrossHyb_core.txt", sep="\t", header=T, as.is=T)
#    crossRefs <- which(mm$MaxCorrCrossHybRefseqEvidence > 0)
    #hist(MaxCorrWithCrossHybTranscript[crossRefs])
#    mm.cross <- mm[crossRefs,]
#    mm.cross <- mm.cross[which(mm.cross$MaxCorrWithCrossHybTranscript >= 0.2),]
#    mps <- mps[grep("core", mps)]
#    mps <- mps[grep("mps$", mps)]
#    mps.df <- read.table(mps, sep="\t", header=T, as.is=T)
#    for(i in 1:dim(mm.cross)[1]){
#      tmp <- mps.df[which(mps.df[,2] == mm.cross$TranscriptClusterId[1]),]
#      tmp.p <- as.character(unlist(strsplit(as.character(tmp[3])," ")))
#      tmp.p <- tmp.p[which(tmp.p != as.character(mm.cross$ProbesetId[1]))]
#      tmp.p <- paste(tmp.p, collapse=" ")
#      mps.df[which(mps.df[,2] == mm.cross$TranscriptClusterId[1]),3] <- tmp.p
      #write.table.....
#    } 
#    Try(setwd(home))
#}

################################################################################
"updateLibs" <- function(){
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
     Try(mbVal <- tkmessageBox(title="Updating Bioconductor Libraries",
				    											message="You are updating all Bioconductor libraries files. \nThe process might take some time!", icon="question",type="yesno",default="yes"
								    						 )#end of tkmessageBox
		  )#end of Try(mbVal..
    	if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
                  return()
		  }
      source("http://bioconductor.org/biocLite.R")
      update.packages(repos=biocinstallRepos(), ask=FALSE)
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
      return()
}
################################################################################
#inernal function used in variantExons
".outvsp" <- function(ov, affyR, vspR, chr, genome){
              # myout <- list("affyname"=names(affyR)[ov[2]],"affystart"=start(affyR)[ov[2]], 
              #                "affyend"=end(affyR)[ov[2]], "affywidth"=width(affyR)[ov[2]],
              #                "vspname"=names(vspR)[ov[1]],"vspstart"=start(vspR)[ov[1]], 
              #                "vspend"=end(vspR)[ov[1]], "vspwidth"=width(vspR)[ov[1]])
              affyname <- strsplit(names(affyR)[ov[2]],"\\.")[[1]][1]
              affystrand <- strsplit(names(affyR)[ov[2]],"\\.")[[1]][2]
              vspname <- strsplit(names(vspR)[ov[1]],"\\.")[[1]][1]
              vspstrand <- strsplit(names(vspR)[ov[1]],"\\.")[[1]][2]
              
              myout <- c(affyname,start(affyR)[ov[2]],end(affyR)[ov[2]], width(affyR)[ov[2]], affystrand,
                         vspname, start(vspR)[ov[1]], end(vspR)[ov[1]], width(vspR)[ov[1]], vspstrand,as.character(sub("chr","", chr)), genome)
   
}

"variantExons" <- function(){
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
    require(IRanges) || stop("\nMissing IRanges library\n")
    #loading exon level annotation
 for(j in c("huex","moex","raex")){
    out.all <- NULL
   if(j=="huex"){
                 genome <- "organism=Human&version=hg19"
                 require(HuExExonProbesetLocationHg19) || stop("\nMissing HuExExonProbesetLocationHg19 package\n")
                 data(HuExExonProbesetLocation)
                 subject<- get("HuExExonProbesetLocation",envir=.GlobalEnv)
   }
   if(j=="moex"){  
                 genome <- "organism=Mouse&version=mm9"
                 require(MoExExonProbesetLocation) || stop("\nMissing MoExExonProbesetLocation package\n")
                 data(MoExExonProbesetLocation)
                 subject<- get("MoExExonProbesetLocation",envir=.GlobalEnv)
   }
   if(j=="raex"){
                 genome <- "organism=Rattus&version=rn4"
                 require(RaExExonProbesetLocation) || stop("\nMissing RaExExonProbesetLocation package\n")
                 data(RaExExonProbesetLocation)
                 subject<- get("RaExExonProbesetLocation",envir=.GlobalEnv)
   }
   #retrieving variant exon file
   vsp.file <- paste("http://www6.unito.it/RRE/Query/ensembleQuery.php?", genome, sep="")
   tmpfile <- tempfile(tmpdir = getwd())
   download.file(vsp.file, tmpfile, mode="w")
   query <- read.table(tmpfile, header=T, as.is=T, sep="\t")
   chr <- unique(query$chromosome)
   chr <- chr[setdiff(seq(1,length(chr)),grep("_", chr))]
   exoncore <-  subject[which(subject$ANNLEVEL == "core"),]
   for(i in chr){
      vsp.tmp <- query[which(query$chromosome==i),]
      vspRanges <- IRanges(start=vsp.tmp$start, end=vsp.tmp$end, names=paste(vsp.tmp$"transcript_id", vsp.tmp$"strand", sep="."))
      #retrieving exon level annotation
      exonchr <-  subject[which(subject$CHR == i),]
      affyRanges <- IRanges(start=as.numeric(exonchr$START), end=as.numeric(exonchr$STOP), names=paste(as.character(exonchr$EPROBESETID),exonchr$STRAND,sep="."))
      ov <- findOverlaps(affyRanges, query=vspRanges)
      ov <- matchMatrix(ov)
      out <- apply(ov, 1,.outvsp, affyR=affyRanges, vspR=vspRanges, chr=i, genome=genome)
      out <- t(out)
      out <- out[which(out[,5] == out[,10]),]
      out.all <- rbind(out.all, out)
   }   
   dimnames(out.all)[[2]] <-  c("affyname", "affystart", "affyend", "affywidth", "affystrand","vspname", "vspstart", "vspend", "vspwidth","vspstrand","chr","genome")
   if(j == "huex"){
                       huex.variantexons <- out.all
                       save(huex.variantexons, file="huex.variantexons.rda")
                       cat("\n huex.variantexons.rda variant exons dataset is now ready to be now copied in oneChannelGUI data dir\n")
   }
   if(j == "moex"){
                       moex.variantexons <- out.all
                       save(moex.variantexons, file="moex.variantexons.rda")
                       cat("\n moex.variantexons.rda variant exons dataset is now ready to be now copied in oneChannelGUI data dir\n")
   }
   if(j == "raex"){
                       raex.variantexons <- out.all
                       save(raex.variantexons, file="raex.variantexons.rda")
                       cat("\n raex.variantexons.rda variant exons dataset is now ready to be now copied in oneChannelGUI data dir\n")
   }
 }
 Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
################################################################################
"exportFASTA" <- function(){
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  require(Biostrings) || stop("\nMissing Biostrings library\n")
  #which organism
  Try(ttGetOrganism <- tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttGetOrganism))
  Try(tkgrab.set(ttGetOrganism))
  Try(tkfocus(ttGetOrganism))
  Try(tkwm.title(ttGetOrganism,"Which organism"))
	
 	Try(tkgrid(tklabel(ttGetOrganism,text="    ")))
  Try(ttGetOrganismTcl <- tclVar("hs"))
  Try(rbIQR.5 <- tkradiobutton(ttGetOrganism,text="H. sapiens",variable=ttGetOrganismTcl,value="hs",font=.affylmGUIglobals$affylmGUIfont2))
  Try(rbIQR.25<-tkradiobutton(ttGetOrganism,text="M. musculus",variable=ttGetOrganismTcl,value="mm",font=.affylmGUIglobals$affylmGUIfont2))
  Try(rbIQR.1<-tkradiobutton(ttGetOrganism,text="R. norvegicus",variable=ttGetOrganismTcl,value="rn",font=.affylmGUIglobals$affylmGUIfont2))
 Try(rbIQR.15<-tkradiobutton(ttGetOrganism,text="B. taurus",variable=ttGetOrganismTcl,value="bo",font=.affylmGUIglobals$affylmGUIfont2))
 
  Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.5))
	Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.25))
  Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.1))
  Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.15))

	Try(tkgrid.configure(rbIQR.5,rbIQR.25,rbIQR.1, rbIQR.15,columnspan=2,sticky="w"))
	
	Try(tkgrid(tklabel(ttGetOrganism,text="    "),tklabel(ttGetOrganism,text="    ")))
  Try(ReturnVal <- "")
  Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
  Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetOrganismTcl));Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
  Try(OK.but     <- tkbutton(ttGetOrganism,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
  Try(Cancel.but <- tkbutton(ttGetOrganism,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	Try(tkgrid(tklabel(ttGetOrganism,text="    "),OK.but,Cancel.but, tklabel(ttGetOrganism,text="    ")))
  Try(tkgrid.configure(OK.but,sticky="e"))
	Try(tkgrid.configure(Cancel.but,sticky="w"))
	Try(tkgrid(tklabel(ttGetOrganism,text="    ")))

  Try(tkbind(ttGetOrganism,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain));}))
  Try(tkbind(OK.but, "<Return>",onOK))
  Try(tkbind(Cancel.but, "<Return>",onCancel))      
  Try(tkwait.window(ttGetOrganism))
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  #miRbase16
  if(ReturnVal == ""){
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
       Try(return())
  } else if (ReturnVal == "hs"){
       #hsa precursor
       Try(data("hsfa",package="oneChannelGUI"))
       Try(hsfa <- get("hsfa",envir=.GlobalEnv))
       Try(writeFASTA(hsfa, file="ncHs.fa"))
       Try(tkmessageBox(title="FASTA reference file",message="The fasta reference file for non-coding RNA quantification is saved in ncHs.fa\n Use it for mapping NGS reads",type="ok", icon="info"))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
       Try(return())
  } else if (ReturnVal == "mm"){
       #mmu precursor
       Try(data("mmfa",package="oneChannelGUI"))
       Try(mmfa <- get("mmfa",envir=.GlobalEnv))
       Try(writeFASTA(mmfa, file="ncMm.fa"))
       Try(tkmessageBox(title="FASTA reference file",message="The fasta reference file for non-coding RNA quantification is saved in ncMm.fa\n Use it for mapping NGS reads",type="ok", icon="info"))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
       Try(return())
  } else if (ReturnVal == "rn"){
       #rno precursor
       Try(data("rnfa",package="oneChannelGUI"))
       Try(rnfa <- get("rnfa",envir=.GlobalEnv))
       Try(writeFASTA(rnfa, file="ncRn.fa"))
       Try(tkmessageBox(title="FASTA reference file",message="The fasta reference file for non-coding RNA quantification is saved in ncRn.fa\n Use it for mapping NGS reads",type="ok", icon="info"))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
       Try(return())

  }
  else if (ReturnVal == "bo"){
       #bta precursor
       Try(data("rnfa",package="oneChannelGUI"))
       Try(rnfa <- get("bofa",envir=.GlobalEnv))
       Try(writeFASTA(rnfa, file="ncBo.fa"))
       Try(tkmessageBox(title="FASTA reference file",message="The fasta reference file for non-coding RNA quantification is saved in ncBo.fa\n Use it for mapping NGS reads",type="ok", icon="info"))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
       Try(return())

  }
}
################################################################################
"ngsperlDownload" <- function(){
      Try(tkmessageBox(title="NGS perl scripts",message="This routine creates a folder for the perl scripts used to reformat NGS primary mapping output."))
      Try(myWD <- getwd())
      #Try(SetWD())
      Try(perlDirLocation <- get("perlDirLocation",envir=affylmGUIenvironment))
      if(perlDirLocation != ""){
             Try(mbVal <- tkmessageBox(title="NGS perl scripts",
				    											message="There already a folder defined for NGS perl scripts.\nDo you want to change it?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		        )#end of Try(mbVal..
    	      if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(setwd(myWD))
			            return()
		        } 
     }
     Try(perlDirLocation  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/ngsperl", sep=""))
     Try(dir.create(perlDirLocation, showWarnings = TRUE, recursive = FALSE))
     Try(setwd(perlDirLocation))
     Try(assign("perlDirLocation", perlDirLocation, affylmGUIenvironment))#directory where NGS perl scripts are located
     Try(cat("\nBegin downloads of NGS scripts.....\n"))
     Try(download.file("http://www.bioinformatica.unito.it/downloads/ngsperl.zip", "ngsperl.zip", mode="wb"))
     if(.Platform$OS.type=="windows"){
                            Try(unzipped1 <- zip.unpack("ngsperl.zip", getwd()))
                            Try(setwd("ngsperl"))
                            Try(system('XCOPY /S *.* ..'))
                            Try(setwd(".."))
                            cat("\nngsperl zip contains: \n", unzipped1, "\n")
     } else{
                            Try(system(paste("unzip ngsperl.zip", sep="")))
     }
     Try(cat("\nEnd unzip NGS scripts.....\n"))
     Try(cat("\nNGS scripts are ready to be used in ", getwd(),"\n"))
     #save the info to be recovered in a new session
     Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
     Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
     Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
     Try(myinfo[which(myinfo[,1]=="perlDirLocation"),2] <- perlDirLocation)
     Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
     Try(assign("perlDirLocation", perlDirLocation, affylmGUIenvironment))
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
     Try(setwd(myWD))
}
################################################################################
"NGSreformat" <- function(){
  Try(ptm <- proc.time())
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  Try(perlDirLocation <- get("perlDirLocation",envir=affylmGUIenvironment))
  Try(if(perlDirLocation == "") ngsperlDownload())
  Try(perlDirLocation <- get("perlDirLocation",envir=affylmGUIenvironment))
  Try(perl.info <- "")
  Try(perl.info <- system("perl -v", intern=T))
  
  if(length(grep("perl", perl.info)) == 0){
      Try(tkmessageBox(title="Perl program",message="Perl program is not installed!",type="ok", icon="error"))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
      Try(return())
  }
  #load target
  Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttExonandTargets))
	Try(tkgrab.set(ttExonandTargets))
	Try(tkfocus(ttExonandTargets))
	Try(tkwm.title(ttExonandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttExonandTargets,cursor="watch"))
			Try(tkfocus(ttExonandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			Try(tkfocus(ttExonandTargets))
	}

	Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="NGS Targets File",message=paste("Either you did not specify a valid NGS Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
#				return()
			})
			Try(tkgrab.release(ttExonandTargets));
			Try(tkdestroy(ttExonandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	Try(tkfocus(ttExonandTargets))
	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttExonandTargets))

	if(Abort==1)
				return(0)
  
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	
  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  Try(rownames(Targets) <- Targets$FileName) 
  Try(var.tmp.pd<-data.frame(names(Targets)))
  Try(names(var.tmp.pd)<-"labelDescription" )
  Try(rownames(var.tmp.pd)<-names(Targets))
  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
  Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
  Try(target.array.names <- paste(tmp1.pd$FileName, ".bed", sep=""))   #giving the extension filename of counts data produced reformatting the output of shrimp
  #NGS reads number and reformatting Tartget in Targets #######################
  Try(tmpTarget <- Targets$Target)
  Try(tmpTarget <- strsplit(tmpTarget, "_"))
  Try(newTarget <- sapply(tmpTarget, function(x)x[1]))
  Try(Targets$Target <- newTarget)
  Try(rownames(Targets) <- NULL)
  Try(assign("Targets",Targets,envir=affylmGUIenvironment))
  Try(totalReads <- sapply(tmpTarget, function(x)x[2]))
  Try(mappedReads <- sapply(tmpTarget, function(x)x[3]))
  Try(assign("totalReads", as.numeric(totalReads),envir=affylmGUIenvironment))
  Try(assign("mappedReads", as.numeric(mappedReads),envir=affylmGUIenvironment))
  
   ###########     
   Try(Targets <- get("Targets",envir=affylmGUIenvironment))
   #defining the the type of input of mapped NGS data
   Try(ttGetNGSinput <- tktoplevel(.affylmGUIglobals$ttMain))
   Try(tkwm.deiconify(ttGetNGSinput))
   Try(tkgrab.set(ttGetNGSinput))
   Try(tkfocus(ttGetNGSinput))
   Try(tkwm.title(ttGetNGSinput,"Selecting Type of NGS input data"))
   #
   Try(tkgrid(tklabel(ttGetNGSinput,text="    ")))
   Try(NGSinputTcl <- tclVar("SHRIMP"))
   Try(rbA <- tkradiobutton(ttGetNGSinput,text="SHRIMP output",variable=NGSinputTcl,value="SHRIMP",font=.affylmGUIglobals$affylmGUIfont2))
   Try(rbB <- tkradiobutton(ttGetNGSinput,text="mature miRNAs from miRanalyser",variable=NGSinputTcl,value="miRanalyser",font=.affylmGUIglobals$affylmGUIfont2))
	 Try(rbC <- tkradiobutton(ttGetNGSinput,text="mature miRNAs from MicroRazerS",variable=NGSinputTcl,value="MicroRazerS",font=.affylmGUIglobals$affylmGUIfont2))
        
   Try(tkgrid(tklabel(ttGetNGSinput,text="    "),rbA))
   Try(tkgrid(tklabel(ttGetNGSinput,text="    "),rbB))
   Try(tkgrid(tklabel(ttGetNGSinput,text="    "),rbC))
      
 	 Try(tkgrid.configure(rbA,rbB, rbC, columnspan=2,sticky="w"))
 	 Try(tkgrid(tklabel(ttGetNGSinput,text="    "),tklabel(ttGetNGSinput,text="    ")))
	 #
	 Try(ReturnNGSinput <- "")
	 Try(
		         onCancel <- function() {
			          Try(ReturnNGSinput <<- "");
			          Try(tkgrab.release(ttGetNGSinput));
			          Try(tkdestroy(ttGetNGSinput));
			          Try(tkfocus(.affylmGUIglobals$ttMain))
		        }
	 )
	 Try(
		       onOK <- function() {
			         Try(ReturnNGSinput <<- tclvalue(NGSinputTcl));
			         Try(tkgrab.release(ttGetNGSinput));
			         Try(tkdestroy(ttGetNGSinput));
			         Try(tkfocus(.affylmGUIglobals$ttMain))
		      }
	 )
   #
	 Try(OK.but     <- tkbutton(ttGetNGSinput,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	 Try(Cancel.but <- tkbutton(ttGetNGSinput,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	 #
	 Try(tkgrid(tklabel(ttGetNGSinput,text="    "),OK.but,Cancel.but,tklabel(ttGetNGSinput,text="    ")))
	 Try(tkgrid.configure(OK.but,sticky="e"))
	 Try(tkgrid.configure(Cancel.but,sticky="w"))
	 Try(tkgrid(tklabel(ttGetNGSinput,text="    ")))
	 #
	 Try(tkbind(ttGetNGSinput,"<Destroy>",function() {ReturnNGSinput <- "";Try(tkgrab.release(ttGetNGSinput));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	 Try(tkbind(OK.but, "<Return>",onOK))
	 Try(tkbind(Cancel.but, "<Return>",onCancel))
	 #
	 Try(tkwait.window(ttGetNGSinput))
   if(ReturnNGSinput == "SHRIMP"){
       #which organism
       Try(ttGetOrganism <- tktoplevel(.affylmGUIglobals$ttMain))
	     Try(tkwm.deiconify(ttGetOrganism))
       Try(tkgrab.set(ttGetOrganism))
       Try(tkfocus(ttGetOrganism))
       Try(tkwm.title(ttGetOrganism,"Which organism"))
	
 	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))
       Try(ttGetOrganismTcl <- tclVar("hs"))
       Try(rbIQR.5 <- tkradiobutton(ttGetOrganism,text="H. sapiens",variable=ttGetOrganismTcl,value="hs",font=.affylmGUIglobals$affylmGUIfont2))
       Try(rbIQR.25<-tkradiobutton(ttGetOrganism,text="M. musculus",variable=ttGetOrganismTcl,value="mm",font=.affylmGUIglobals$affylmGUIfont2))
       Try(rbIQR.50<-tkradiobutton(ttGetOrganism,text="oneChannelGUI miRbase precursors",variable=ttGetOrganismTcl,value="mirbase",font=.affylmGUIglobals$affylmGUIfont2))
       Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.5))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.25))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.50))

	     Try(tkgrid.configure(rbIQR.5,rbIQR.25, rbIQR.50,columnspan=2,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),tklabel(ttGetOrganism,text="    ")))
       Try(ReturnVal <- "")
       Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetOrganismTcl));Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(OK.but     <- tkbutton(ttGetOrganism,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
       Try(Cancel.but <- tkbutton(ttGetOrganism,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),OK.but,Cancel.but, tklabel(ttGetOrganism,text="    ")))
       Try(tkgrid.configure(OK.but,sticky="e"))
	     Try(tkgrid.configure(Cancel.but,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))

       Try(tkbind(ttGetOrganism,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain));}))
       Try(tkbind(OK.but, "<Return>",onOK))
       Try(tkbind(Cancel.but, "<Return>",onCancel))      
       Try(tkwait.window(ttGetOrganism))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  
       if(ReturnVal == ""){
            Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
            Try(return())
       } else if (ReturnVal == "hs"){
             cat("Be patient!!!!.....\n")
             cat("reformatting data aligned using H. sapiens as reference\n")
             for(i in Targets$FileName){
                cat("Processing ", i,"\n")
                system(paste("perl", paste(perlDirLocation, "/shrimpENSEMBL2genominator.hs.pl", sep=""), i, sep=" "))
            }
       } else if (ReturnVal == "mm"){
             cat("Be patient!!!!.....\n")
             cat("reformatting data aligned using M. musculus as reference genome\n")
             for(i in Targets$FileName){
                cat("Processing ", i,"\n")
                system(paste("perl", paste(perlDirLocation, "/shrimpENSEMBL2genominator.mm.pl", sep=""), i, sep=" "))
            }
       } else if (ReturnVal == "mirbase"){
             cat("Be patient!!!!.....\n")
             cat("reformatting data aligned using the miRbase precursors, generated using oneChannelGUI \nExport miRbase fasta reference file for microRNA-seq quantitative analysis function,\nas reference\n")
             for(i in Targets$FileName){
                cat("Processing ", i,"\n")
                system(paste("perl", paste(perlDirLocation, "/shrimpENSEMBL2genominator.mirbase.pl", sep=""), i, sep=" "))
            }
       } 
    } else if(ReturnNGSinput == "MicroRazerS"){
       #which organism
       Try(ttGetOrganism <- tktoplevel(.affylmGUIglobals$ttMain))
	     Try(tkwm.deiconify(ttGetOrganism))
       Try(tkgrab.set(ttGetOrganism))
       Try(tkfocus(ttGetOrganism))
       Try(tkwm.title(ttGetOrganism,"Which organism"))
	
 	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))
       Try(ttGetOrganismTcl <- tclVar("hs"))
       Try(rbIQR.5 <- tkradiobutton(ttGetOrganism,text="H. sapiens",variable=ttGetOrganismTcl,value="hs",font=.affylmGUIglobals$affylmGUIfont2))
       Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.5))

	     Try(tkgrid.configure(rbIQR.5, columnspan=2,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),tklabel(ttGetOrganism,text="    ")))
       Try(ReturnVal <- "")
       Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetOrganismTcl));Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(OK.but     <- tkbutton(ttGetOrganism,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
       Try(Cancel.but <- tkbutton(ttGetOrganism,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),OK.but,Cancel.but, tklabel(ttGetOrganism,text="    ")))
       Try(tkgrid.configure(OK.but,sticky="e"))
	     Try(tkgrid.configure(Cancel.but,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))

       Try(tkbind(ttGetOrganism,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain));}))
       Try(tkbind(OK.but, "<Return>",onOK))
       Try(tkbind(Cancel.but, "<Return>",onCancel))      
       Try(tkwait.window(ttGetOrganism))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  
       if(ReturnVal == ""){
            Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
            Try(return())
       } else if (ReturnVal == "hs"){
             cat("Be patient!!!!.....\n")
             cat("reformatting data aligned using H. sapiens as reference genome\n")
             for(i in Targets$FileName){
                cat("Processing ", i,"\n")
                system(paste("perl", paste(perlDirLocation, "/MicroRazerSENSEMBL2genominator.hs.pl", sep=""), i, sep=" "))
            }
       }
    } else if(ReturnNGSinput == "miRanalyser"){
              Try(tkmessageBox(title="NGS data reformatting",message="Tab delimited files for mature miRNAs produced by miRanalyser can be directly loaded on oneChannelGUI without reformatting."))
    }
    Try(usedtime <- proc.time() - ptm)
    Try(cat("\nUsed CPU time (min) ",usedtime[3]/60,"\n"))
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
################################################################################
"meVDownload" <- function(){
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
      Try(tkmessageBox(title="meV software",message="This routine creates a folder to install the meV software."))
      Try(myWD <- getwd())
      #Try(SetWD())
      Try(meVDirLocation.Available <- get("meVDirLocation.Available",envir=affylmGUIenvironment))
      if(meVDirLocation.Available){
             Try(mbVal <- tkmessageBox(title="meV software",
				    											message="There already a folder defined for meV software.\nDo you want to change it?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		        )#end of Try(mbVal..
    	      if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(setwd(myWD))
			            return()
		        } 
     }
     Try(meVDirLocation  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/meV", sep=""))
     Try(dir.create(meVDirLocation, showWarnings = TRUE, recursive = FALSE))
     Try(setwd(meVDirLocation))
     Try(assign("meVDirLocation", meVDirLocation, affylmGUIenvironment))#directory where NGS perl scripts are located
     Try(cat("\nBegin downloads of meV.....\n"))
  #   Try(download.file("http://downloads.sourceforge.net/project/mev-tm4/mev-tm4/MeV%204.6.2/MeV_4_6_2_r2536_win.zip?r=&ts=1296999833&use_mirror=heanet", "meV.zip", mode="wb"))
     Try(download.file("http://sourceforge.net/projects/mev-tm4/files/mev-tm4/MeV%204.6.2/MeV_4_6_2_r2536_win.zip/download", "meV.zip", mode="wb"))
     if(.Platform$OS.type=="windows"){
                            Try(unzipped1 <- zip.unpack("meV.zip", getwd()))
                            Try(cat("\nThe meV downloaded version is MeV_4_6_2\n"))
                            Try(setwd("MeV_4_6_2"))
                            Try(system('XCOPY /S *.* ..'))
                            Try(setwd(".."))
     } else{
                            Try(system(paste("unzip meV.zip", sep="")))
                            Try(system("cp -fR ./MeV_4_6_2/* ."))
                            Try(system("rm -fR ./MeV_4_6_2/"))
     }
     Try(cat("\nEnd unzip meV files.....\n"))
     Try(cat("\nmeV software is ready to be used in ", getwd(),"\n"))
     #save the info to be recovered in a new session
     Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
     Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
     Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
     Try(myinfo[which(myinfo[,1]=="meVDirLocation"),2] <- meVDirLocation)
     Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
     Try(assign("meVDirLocation", meVDirLocation, affylmGUIenvironment))
     assign("meVDirLocation.Available",TRUE,affylmGUIenvironment)
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
     Try(setwd(myWD))
}
################################################################################
#external package info
"extPckInfo" <- function(){
     Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
     Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
     Try(tmp <- system("perl -v", intern = T))
     Try(if(length(tmp) > 0) perl.version <- tmp[2])
     Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
     Try(tkmessageBox(title="External Packages associated to oneChannelGUI",message=paste("Affymetrix libraries: ", myinfo[1,2],
                                                                                          "\nAPT tools: ",myinfo[2,2],
                                                                                          "\nmeV clustering tool: ",myinfo[4,2],
                                                                                          "\nperl sotware: ", perl.version,
                                                                                          "\nperl MPS reformatting scripts: ",myinfo[3,2],
                                                                                          "\n",sep="")))
}
################################################################################
"combining2eSet" <- function(){
    Try(tkmessageBox(title="combining two datasets",message="This routine combines two matrices having the same number of row and the same row identifiers."))
    Try(tempFileName1 <- tclvalue(tkgetOpenFile(filetypes = "{{Text Files} {.txt}} {{All files} *}")))
    if (!nchar(tempFileName1)) {
                tkfocus(.affylmGUIglobals$ttMain)
                return()
    }
    Try(mySel1 <- read.table(tempFileName1, sep = "\t", header = T, as.is = TRUE, row.names=1))
    Try(tempFileName2 <- tclvalue(tkgetOpenFile(filetypes = "{{Text Files} {.txt}} {{All files} *}")))
    if (!nchar(tempFileName2)) {
                tkfocus(.affylmGUIglobals$ttMain)
                return()
    }
    Try(mySel2 <- read.table(tempFileName2, sep = "\t", header = T, as.is = TRUE, row.names=1))
    
    Try(mySel1 <- mySel1[order(rownames(mySel1)),])
    Try(mySel2 <- mySel2[order(rownames(mySel2)),])
    if(identical(rownames(mySel1), rownames(mySel2))){
        tempFileName1 <- unlist(strsplit(tempFileName1, "/"))
        tempFileName1 <- tempFileName1[length(tempFileName1)]
        tempFileName1 <- sub(".txt$", "", tempFileName1) 
        tempFileName2 <- unlist(strsplit(tempFileName2, "/"))
        tempFileName2 <- tempFileName2[length(tempFileName2)]
        tempFileName2 <- sub(".txt$", "", tempFileName2) 
        tempFileName <- paste(tempFileName1, "_", tempFileName2,".txt",sep="")
        Try(mySel <- cbind(mySel1, mySel2))
        Try(write.table(mySel, file = tempFileName,  sep = "\t", quote = FALSE, col.names = NA))
        Try(tkmessageBox(title="Combining two datasets",message=paste("The combined dataset is available in",getwd(),"as",tempFileName,sep="\n")))
        Try(return())
    } else{
      Try(tkmessageBox(title="Combining datasets",message="The two datasets do not have the same row identifiers.\nThey cannot be combined!",icon="error"))
      Try(return())                
    }

}
################################################################################